src/Entity/Booking.php
<?php

namespace App\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity(repositoryClass="App\Repository\BookingRepository")
 * @ORM\HasLifecycleCallbacks()
 */
class Booking
{
    /**
     * @ORM\Id()
     * @ORM\GeneratedValue()
     * @ORM\Column(type="integer")
     */
    private $id;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\User", inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     */
    private $booker;

    /**
     * @ORM\ManyToOne(targetEntity="App\Entity\Ad", inversedBy="bookings")
     * @ORM\JoinColumn(nullable=false)
     */
    private $ad;

    /**
     * @ORM\Column(type="datetime")
     *@Assert\GreaterThan("today",message="la date doit etre apres d auhourd hui",groups={"front"})
     */
    private $startDate;

    /**
     * @ORM\Column(type="datetime")
     */
    private $createdAt;

    /**
     * @ORM\Column(type="float")
     */
    private $amount;

    /**
     * @ORM\Column(type="datetime")
     *@Assert\GreaterThan(propertyPath="startDate",message="la date doit etre apres le debut date")
     */
    private $endDate;

    /**
     * @ORM\Column(type="text", nullable=true)
     */
    private $comment;

    /**
     * @ORM\PrePersist
     *@ORM\PreUpdate
     */
    public function prePersist(){
      if(empty($this->createdAt)){
        $this->createdAt=new \DateTime();
      }
      if(empty($this->amount)){
$this->amount=$this->ad->getPrice() * $this->getDuration();
      }
    }

    public function isBookableDates(){
      $notAvailableDays=$this->ad->getNotAvailableDays();
      $bookingDays=$this->getDays();
      $days=array_map(function($day){
        return $day->format('Y-m-d');
      },$bookingDays);
      $notAvailable=array_map(function($day){
        return $day->format('Y-m-d');
      },$notAvailableDays);
      foreach($days as $day){
        if(array_search($day,$notAvailable)!== false)return false;
      }
      return true;

    }

    public function getDays(){
      $resultat=range(
        $this->startDate->getTimestamp(),
        $this->endDate->getTimestamp(),
        24*60*60
      );
      $days=array_map(function($dayTimestap){
        return new \DateTime(date('Y-m-d',$dayTimestap));
      },$resultat);
      return $days;
    }

    public function getDuration(){
    $diff=$this->endDate->diff($this->startDate);
    return $diff->days;
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getBooker(): ?User
    {
        return $this->booker;
    }

    public function setBooker(?User $booker): self
    {
        $this->booker = $booker;

        return $this;
    }

    public function getAd(): ?Ad
    {
        return $this->ad;
    }

    public function setAd(?Ad $ad): self
    {
        $this->ad = $ad;

        return $this;
    }

    public function getStartDate(): ?\DateTimeInterface
    {
        return $this->startDate;
    }

    public function setStartDate(\DateTimeInterface $startDate): self
    {
        $this->startDate = $startDate;

        return $this;
    }

    public function getCreatedAt(): ?\DateTimeInterface
    {
        return $this->createdAt;
    }

    public function setCreatedAt(\DateTimeInterface $createdAt): self
    {
        $this->createdAt = $createdAt;

        return $this;
    }

    public function getAmount(): ?float
    {
        return $this->amount;
    }

    public function setAmount(float $amount): self
    {
        $this->amount = $amount;

        return $this;
    }

    public function getEndDate(): ?\DateTimeInterface
    {
        return $this->endDate;
    }

    public function setEndDate(\DateTimeInterface $endDate): self
    {
        $this->endDate = $endDate;

        return $this;
    }

    public function getComment(): ?string
    {
        return $this->comment;
    }

    public function setComment(?string $comment): self
    {
        $this->comment = $comment;

        return $this;
    }
}

src/Form/BookingType.php
<?php

namespace App\Form;

use App\Entity\Booking;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;
use Symfony\Component\Form\Extension\Core\Type\TextType;
use Symfony\Component\Form\Extension\Core\Type\TextareaType;
use App\Form\DataTransformer\FrenchToDateTimeTransformer;

class BookingType extends AbstractType
{

  private $transformer;


public function __construct(FrenchToDateTimeTransformer $transformer){
  $this->transformer=$transformer;
}

    public function buildForm(FormBuilderInterface $builder, array $options)
    {
        $builder
            ->add('startDate',TextType::class)
            ->add('endDate',TextType::class)
            ->add('comment',TextareaType::class,['required'=>false])
        ;
        $builder->get('startDate')->addModelTransformer($this->transformer);
        $builder->get('endDate')->addModelTransformer($this->transformer);
    }

    public function configureOptions(OptionsResolver $resolver)
    {
        $resolver->setDefaults([
            'data_class' => Booking::class,
        ]);
    }
}

src/Controller/BookingController.php
<?php

namespace App\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\Routing\Annotation\Route;
use Doctrine\Common\Persistence\ObjectManager;
use Symfony\Component\HttpFoundation\Request;
use App\Entity\Ad;
use App\Entity\Booking;
use App\Form\BookingType;
use App\Entity\Comment;
use App\Form\CommentType;
use Sensio\Bundle\FrameworkExtraBundle\Configuration\IsGranted;

class BookingController extends AbstractController
{
    /**
     * @Route("/ads/{id}/book", name="booking_create")
     *@IsGranted("ROLE_USER")
     */
    public function book(Ad $ad,Request $request,ObjectManager $manager)
    {
      $booking=new Booking();
      $form=$this->createForm(BookingType::class,$booking,["validation_groups"=>["Default","front"]]);


      $form->handleRequest($request);
      if($form->isSubmitted() && $form->isValid()){
  $user=$this->getUser();
  $booking->setBooker($user);
  $booking->setAd($ad);

if(!$booking->isBookableDates()){
  $this->addFlash(
    'warning',"dates are taken"
  );
}else{

        $manager->persist($booking);
        $manager->flush();
        // $this->addFlash('success','votre item est modifie');
         return $this->redirectToRoute('booking_show',['id' => $booking->getId()]);
      //   return $this->redirectToRoute('booking_show',['booking' => $booking]);
    }}

        return $this->render('booking/book.html.twig', [
            'ad' => $ad,'form' => $form->createView()
        ]);
    }

    /**
     * @Route("/booking/{id}", name="booking_show")
     *@IsGranted("ROLE_USER")
     */
    public function show(Booking $booking, Request $request,ObjectManager $manager)
    {
      $comment=new Comment();

      $form=$this->createForm(CommentType::class,$comment);
$form->handleRequest($request);
if($form->isSubmitted() && $form->isValid()){
  $comment->setAd($booking->getAd())
          ->setAuthor($this->getUser());
$manager->persist($comment);
$manager->flush();
$this->addFlash('success','votre commentaire est pris');
}

        return $this->render('booking/show.html.twig', [
            'booking' => $booking,
            'form' => $form->createView()
        ]);
    }
}

templates/booking/book.html.twig
{% extends 'base.html.twig' %}

{% block title %}Hello Booking!{% endblock %}

{% block stylesheets %}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/css/bootstrap-datepicker.min.css"/>
{% endblock %}

{% block body %}
<div class="container">
<h1>reserver l annonce {{ad.title}}</h1>
{{form_start(form)}}
<div class="alert alert-light">
<div class="row">
<div class="col">
{{form_row(form.startDate)}}
</div>
<div class="col">
{{form_row(form.endDate)}}
</div></div></div>
<h4>montant de sejour:<span id="amount">...</span> &euro;</h4>
<span id="days">0</span> nuits a {{ad.price}}/nuit
<h2>you have comment</h2>
{{form_row(form.comment)}}
<button type="submit" class="btn btn-success">reserve</button>
{{form_end(form)}}
</div>
{% endblock %}

{% block javascripts %}
<script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-datepicker/1.8.0/js/bootstrap-datepicker.min.js">
</script><script>
$(document).ready(function(){
$('#booking_startDate, #booking_endDate').datepicker({
format:'dd/mm/yyyy',
datesDisabled:[
{%for day in ad.getNotAvailableDays()%}
"{{day.format('d/m/Y')}}",
{%endfor%}
],
startDate:new Date()
});
$('#booking_startDate, #booking_endDate').on('change',calculateAmount);
});
function calculateAmount(){
const endDate=new Date($('#booking_endDate').val().replace(/(\d+)\/(\d+)\/(\d{4})/,'$3-$2-$1'));
{#}
18/09/2108
(\d+)\/(\d+)\/(\d{4})
2018-09-18
{#}
const startDate=new Date($('#booking_startDate').val().replace(/(\d+)\/(\d+)\/(\d{4})/,'$3-$2-$1'));
if(startDate && endDate && startDate < endDate){
const DAY_TIME=24*60*60*1000;
const interval=endDate.getTime()-startDate.getTime();
const days = interval/ DAY_TIME;
const amount=days*{{ad.price}};
$('#days').text(days);
$('#amount').text(amount);

}
}


</script>
{% endblock %}

templates/booking/show.html.twig
{% extends 'base.html.twig' %}

{% block title %}reservation n{{booking.id}}{% endblock %}

{% block body %}

{%set ad=booking.ad%}
{%set author=ad.author%}
<div class="container">
<h1>votre reservation n{{booking.id}}</h1>
<div class="row">
<div class="col">
<div class="alert alert-light">
<h2>details</h2>
<dl class="row">
<dt class="col-md-4">numero</dt>
<dt class="col-md-8">{{booking.id}}</dd>
<dt class="col-md-4">date start</dt>
<dt class="col-md-8">{{booking.startDate | date('d/m/Y')}}</dd>
<dt class="col-md-4">date end</dt>
<dt class="col-md-8">{{booking.endDate | date('d/m/Y')}}</dd>
<dt class="col-md-4">num de nuit</dt>
<dt class="col-md-8">{{booking.duration}}</dd>
<dt class="col-md-4">total</dt>
<dt class="col-md-8">{{booking.amount}} &euro</dd>
<dt class="col-md-4">comment</dt>
<dt class="col-md-8">{{booking.comment}}</dd>
</dl><hr>
<h2 class="alert-heading">votre hote</h2>
<div class="row">
<div class="col-3">
<img src="../{{author.picture}}" width=100%>
</div>
<div class="col-9">
<h4>
<a href="{{path('user',{'id':author.id})}}">{{author.firstName}}</a></h4>
<span class="badge badge-primary">{{author.ads | length}}annonces</span>
</div></div>
{{author.description}}
</div>

<div class="alert alert-light" id="comment">
<h2 class="alert-heading">votre avis compte</h2>
{%if date() > date(booking.endDate)%}
{%set comment=booking.ad.getCommentFromAuthor(app.user)%}
{%if comment is not null%}
<blockquote>
{{comment.content}}
</blockquote>
note: {% include 'partials/rating.html.twig' with {'rating':comment.rating}%}
{%else%}
{{form_start(form)}}
{{form_widget(form)}}
<button type="submit" class="btn btn-success">save</button>
{{form_end(form)}}
{%endif%}
{%else%}
you have to wait until the end of your Reservation
{%endif%}

</div>
</div>
<div class="col">
<div class="alert alert-light">
<h2 class="alert-heading">votre hebergement</h2>
<h4><a href="{{path('ads_show',{'id':ad.id})}}">{{ad.title}}</a></h4>
<img src="../{{ad.coverImage}}" width=100%>
{{ad.content}}
</div></div></div></div>
{% endblock %}